com.google.gwt.resources.converter

## Class GssGenerationVisitor

- java.lang.Object
- - com.google.gwt.resources.css.ast.CssVisitor
  - - com.google.gwt.resources.converter.ExtendedCssVisitor
    - - com.google.gwt.resources.converter.GssGenerationVisitor

-     public class GssGenerationVisitor
      extends ExtendedCssVisitor

  The GssGenerationVisitor turns a css tree into a gss string.

- - ### Field Summary

    - ### Fields inherited from class com.google.gwt.resources.css.ast.CssVisitor

      `UNMODIFIABLE_CONTEXT`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `GssGenerationVisitor(com.google.gwt.dev.util.TextOutput out, java.util.Map<java.lang.String,java.lang.String> cssToGssConstantMapping, boolean lenient, TreeLogger treeLogger, com.google.gwt.thirdparty.guava.common.base.Predicate<java.lang.String> simpleBooleanConditionPredicate)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `endVisit(com.google.gwt.resources.css.ast.CssFontFace x, com.google.gwt.resources.css.ast.Context ctx)`
    `void` | `endVisit(com.google.gwt.resources.css.ast.CssIf x, com.google.gwt.resources.css.ast.Context ctx)`
    `void` | `endVisit(com.google.gwt.resources.css.ast.CssMediaRule x, com.google.gwt.resources.css.ast.Context ctx)`
    `void` | `endVisit(com.google.gwt.resources.css.ast.CssNoFlip x, com.google.gwt.resources.css.ast.Context ctx)`
    `void` | `endVisit(com.google.gwt.resources.css.ast.CssPageRule x, com.google.gwt.resources.css.ast.Context ctx)`
    `void` | `endVisit(com.google.gwt.resources.css.ast.CssRule x, com.google.gwt.resources.css.ast.Context ctx)`
    `void` | `endVisit(com.google.gwt.resources.css.ast.CssSprite x, com.google.gwt.resources.css.ast.Context ctx)`
    `void` | `endVisit(com.google.gwt.resources.css.ast.CssUnknownAtRule x, com.google.gwt.resources.css.ast.Context ctx)`
    `java.lang.String` | `getContent()`
    `boolean` | `visit(com.google.gwt.resources.css.ast.CssCharset x, com.google.gwt.resources.css.ast.Context ctx)`
    `boolean` | `visit(com.google.gwt.resources.css.ast.CssDef x, com.google.gwt.resources.css.ast.Context ctx)`
    `boolean` | `visit(CssElIf x, com.google.gwt.resources.css.ast.Context ctx)`
    `boolean` | `visit(CssElse x, com.google.gwt.resources.css.ast.Context ctx)`
    `boolean` | `visit(com.google.gwt.resources.css.ast.CssEval x, com.google.gwt.resources.css.ast.Context ctx)`
    `boolean` | `visit(com.google.gwt.resources.css.ast.CssExternalSelectors x, com.google.gwt.resources.css.ast.Context ctx)`
    `boolean` | `visit(com.google.gwt.resources.css.ast.CssFontFace x, com.google.gwt.resources.css.ast.Context ctx)`
    `boolean` | `visit(com.google.gwt.resources.css.ast.CssIf x, com.google.gwt.resources.css.ast.Context ctx)`
    `boolean` | `visit(com.google.gwt.resources.css.ast.CssMediaRule x, com.google.gwt.resources.css.ast.Context ctx)`
    `boolean` | `visit(com.google.gwt.resources.css.ast.CssNoFlip x, com.google.gwt.resources.css.ast.Context ctx)`
    `boolean` | `visit(com.google.gwt.resources.css.ast.CssPageRule x, com.google.gwt.resources.css.ast.Context ctx)`
    `boolean` | `visit(com.google.gwt.resources.css.ast.CssProperty x, com.google.gwt.resources.css.ast.Context ctx)`
    `boolean` | `visit(com.google.gwt.resources.css.ast.CssRule x, com.google.gwt.resources.css.ast.Context ctx)`
    `boolean` | `visit(com.google.gwt.resources.css.ast.CssSelector x, com.google.gwt.resources.css.ast.Context ctx)`
    `boolean` | `visit(com.google.gwt.resources.css.ast.CssSprite x, com.google.gwt.resources.css.ast.Context ctx)`
    `boolean` | `visit(com.google.gwt.resources.css.ast.CssUrl x, com.google.gwt.resources.css.ast.Context ctx)`

    - ### Methods inherited from class com.google.gwt.resources.converter.ExtendedCssVisitor

      `endVisit, endVisit`

    - ### Methods inherited from class com.google.gwt.resources.css.ast.CssVisitor

      `accept, accept, acceptWithInsertRemove, doAccept, doAccept, doAcceptWithInsertRemove, doTraverse, endVisit, endVisit, endVisit, endVisit, endVisit, endVisit, endVisit, endVisit, visit, visit`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### GssGenerationVisitor

          public GssGenerationVisitor(com.google.gwt.dev.util.TextOutput out,
                                      java.util.Map<java.lang.String,java.lang.String> cssToGssConstantMapping,
                                      boolean lenient,
                                      TreeLogger treeLogger,
                                      com.google.gwt.thirdparty.guava.common.base.Predicate<java.lang.String> simpleBooleanConditionPredicate)

  - ### Method Detail

    - #### getContent

          public java.lang.String getContent()

    - #### endVisit

          public void endVisit(com.google.gwt.resources.css.ast.CssFontFace x,
                               com.google.gwt.resources.css.ast.Context ctx)

      Overrides:
        `endVisit` in class `com.google.gwt.resources.css.ast.CssVisitor`
      Parameters:
        `x` - the node being visited
        `ctx` - the context for the visit

    - #### endVisit

          public void endVisit(com.google.gwt.resources.css.ast.CssMediaRule x,
                               com.google.gwt.resources.css.ast.Context ctx)

      Overrides:
        `endVisit` in class `com.google.gwt.resources.css.ast.CssVisitor`
      Parameters:
        `x` - the node being visited
        `ctx` - the context for the visit

    - #### endVisit

          public void endVisit(com.google.gwt.resources.css.ast.CssPageRule x,
                               com.google.gwt.resources.css.ast.Context ctx)

      Overrides:
        `endVisit` in class `com.google.gwt.resources.css.ast.CssVisitor`
      Parameters:
        `x` - the node being visited
        `ctx` - the context for the visit

    - #### endVisit

          public void endVisit(com.google.gwt.resources.css.ast.CssUnknownAtRule x,
                               com.google.gwt.resources.css.ast.Context ctx)

      Overrides:
        `endVisit` in class `com.google.gwt.resources.css.ast.CssVisitor`
      Parameters:
        `x` - the node being visited
        `ctx` - the context for the visit

    - #### visit

          public boolean visit(com.google.gwt.resources.css.ast.CssSprite x,
                               com.google.gwt.resources.css.ast.Context ctx)

      Overrides:
        `visit` in class `com.google.gwt.resources.css.ast.CssVisitor`
      Parameters:
        `x` - the node being visited
        `ctx` - the context for the visit

    - #### endVisit

          public void endVisit(com.google.gwt.resources.css.ast.CssSprite x,
                               com.google.gwt.resources.css.ast.Context ctx)

      Overrides:
        `endVisit` in class `com.google.gwt.resources.css.ast.CssVisitor`
      Parameters:
        `x` - the node being visited
        `ctx` - the context for the visit

    - #### visit

          public boolean visit(com.google.gwt.resources.css.ast.CssDef x,
                               com.google.gwt.resources.css.ast.Context ctx)

      Overrides:
        `visit` in class `com.google.gwt.resources.css.ast.CssVisitor`
      Parameters:
        `x` - the node being visited
        `ctx` - the context for the visit

    - #### visit

          public boolean visit(com.google.gwt.resources.css.ast.CssEval x,
                               com.google.gwt.resources.css.ast.Context ctx)

      Overrides:
        `visit` in class `com.google.gwt.resources.css.ast.CssVisitor`
      Parameters:
        `x` - the node being visited
        `ctx` - the context for the visit

    - #### visit

          public boolean visit(com.google.gwt.resources.css.ast.CssUrl x,
                               com.google.gwt.resources.css.ast.Context ctx)

      Overrides:
        `visit` in class `com.google.gwt.resources.css.ast.CssVisitor`
      Parameters:
        `x` - the node being visited
        `ctx` - the context for the visit

    - #### visit

          public boolean visit(com.google.gwt.resources.css.ast.CssRule x,
                               com.google.gwt.resources.css.ast.Context ctx)

      Overrides:
        `visit` in class `com.google.gwt.resources.css.ast.CssVisitor`
      Parameters:
        `x` - the node being visited
        `ctx` - the context for the visit

    - #### endVisit

          public void endVisit(com.google.gwt.resources.css.ast.CssRule x,
                               com.google.gwt.resources.css.ast.Context ctx)

      Overrides:
        `endVisit` in class `com.google.gwt.resources.css.ast.CssVisitor`
      Parameters:
        `x` - the node being visited
        `ctx` - the context for the visit

    - #### visit

          public boolean visit(com.google.gwt.resources.css.ast.CssNoFlip x,
                               com.google.gwt.resources.css.ast.Context ctx)

      Overrides:
        `visit` in class `com.google.gwt.resources.css.ast.CssVisitor`
      Parameters:
        `x` - the node being visited
        `ctx` - the context for the visit

    - #### visit

          public boolean visit(com.google.gwt.resources.css.ast.CssExternalSelectors x,
                               com.google.gwt.resources.css.ast.Context ctx)

      Overrides:
        `visit` in class `com.google.gwt.resources.css.ast.CssVisitor`
      Parameters:
        `x` - the node being visited
        `ctx` - the context for the visit

    - #### visit

          public boolean visit(com.google.gwt.resources.css.ast.CssCharset x,
                               com.google.gwt.resources.css.ast.Context ctx)

      Overrides:
        `visit` in class `com.google.gwt.resources.css.ast.CssVisitor`
      Parameters:
        `x` - the node being visited
        `ctx` - the context for the visit

    - #### endVisit

          public void endVisit(com.google.gwt.resources.css.ast.CssNoFlip x,
                               com.google.gwt.resources.css.ast.Context ctx)

      Overrides:
        `endVisit` in class `com.google.gwt.resources.css.ast.CssVisitor`
      Parameters:
        `x` - the node being visited
        `ctx` - the context for the visit

    - #### visit

          public boolean visit(com.google.gwt.resources.css.ast.CssProperty x,
                               com.google.gwt.resources.css.ast.Context ctx)

      Overrides:
        `visit` in class `com.google.gwt.resources.css.ast.CssVisitor`
      Parameters:
        `x` - the node being visited
        `ctx` - the context for the visit

    - #### visit

          public boolean visit(CssElse x,
                               com.google.gwt.resources.css.ast.Context ctx)

      Overrides:
        `visit` in class `ExtendedCssVisitor`
      Parameters:
        `x` - the node being visited
        `ctx` - the context for the visit

    - #### visit

          public boolean visit(CssElIf x,
                               com.google.gwt.resources.css.ast.Context ctx)

      Overrides:
        `visit` in class `ExtendedCssVisitor`
      Parameters:
        `x` - the node being visited
        `ctx` - the context for the visit

    - #### endVisit

          public void endVisit(com.google.gwt.resources.css.ast.CssIf x,
                               com.google.gwt.resources.css.ast.Context ctx)

      Overrides:
        `endVisit` in class `com.google.gwt.resources.css.ast.CssVisitor`
      Parameters:
        `x` - the node being visited
        `ctx` - the context for the visit

    - #### visit

          public boolean visit(com.google.gwt.resources.css.ast.CssIf x,
                               com.google.gwt.resources.css.ast.Context ctx)

      Overrides:
        `visit` in class `com.google.gwt.resources.css.ast.CssVisitor`
      Parameters:
        `x` - the node being visited
        `ctx` - the context for the visit

    - #### visit

          public boolean visit(com.google.gwt.resources.css.ast.CssFontFace x,
                               com.google.gwt.resources.css.ast.Context ctx)

      Overrides:
        `visit` in class `com.google.gwt.resources.css.ast.CssVisitor`
      Parameters:
        `x` - the node being visited
        `ctx` - the context for the visit

    - #### visit

          public boolean visit(com.google.gwt.resources.css.ast.CssMediaRule x,
                               com.google.gwt.resources.css.ast.Context ctx)

      Overrides:
        `visit` in class `com.google.gwt.resources.css.ast.CssVisitor`
      Parameters:
        `x` - the node being visited
        `ctx` - the context for the visit

    - #### visit

          public boolean visit(com.google.gwt.resources.css.ast.CssPageRule x,
                               com.google.gwt.resources.css.ast.Context ctx)

      Overrides:
        `visit` in class `com.google.gwt.resources.css.ast.CssVisitor`
      Parameters:
        `x` - the node being visited
        `ctx` - the context for the visit

    - #### visit

          public boolean visit(com.google.gwt.resources.css.ast.CssSelector x,
                               com.google.gwt.resources.css.ast.Context ctx)

      Overrides:
        `visit` in class `com.google.gwt.resources.css.ast.CssVisitor`
      Parameters:
        `x` - the node being visited
        `ctx` - the context for the visit